#!/bin/bash

# 编写一个Shell脚本，接受一个目录名作为参数，将目录中所有文件打包成xx.tar.bz2到它的父级目录，然后再删除该目录及其所有子目录和文件。

if [ $# -ne 1 ]; then
    echo "请提供目录参数"
    exit 1
fi

dir=$1
# 获取父级目录
father_dir=`dirname $dir`
# 获取目录名
dir_name=`basename $dir`
# 打包目录中所有文件
tar -jcvf $father_dir/$dir_name.tar.bz2 $dir
# 判断是否打包成功
if [ $? -eq 0 ];then
    # 删除目录
    rm -rf $dir
    echo "已删除目录 $dir"
else
    echo "打包失败"
fi
