// 创建一个无名管道，并在父子进程之间传递数据。
#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <string.h>

int main()
{
    int fd[2];
    int f = pipe(fd);
    if (f == -1)
    {
        perror("pipe");
        return 1;
    }

    int pid = fork();
    if (pid == 0)
    {
        // 子进程
        close(fd[1]); // 关闭写通道
        char buf[32] = "";
        int len = read(fd[0], buf, 32);
        buf[strlen(buf) - 1] = '\0';

        printf("子进程(%d)收到父进程(%d)数据: %s\n", getpid(), getppid(), buf);
        close(fd[0]);
        _exit(0);
    }
    else if (pid > 0)
    {
        // 父进程
        close(fd[0]);
        printf("父进程正在写入数据\n");
        /*
            父进程在写入数据之后进行了sleep(2)的延迟操作，以确保子进程在读取之前有足够的时间启动。
            这样可以避免子进程在尝试读取数据之前管道还没有数据可读的情况。
        */
        // sleep(2);
        // char buf[32] = "hello pipe";
        char buf[32];
        fgets(buf, 32, stdin);
        write(fd[1], buf, strlen(buf));
        close(fd[1]);
    }
    return 0;
}