#include <sys/stat.h>
#include <sys/wait.h>
#include <fcntl.h>
#include <semaphore.h>
#include <stdio.h>
#include <unistd.h>

// 命名信号实例

void printer(char *msg)
{
    while (*msg)
    {
        printf("%c", *msg++); // 打印字符
        fflush(stdout);       // 刷新控制台
        sleep(1);
    }
}

int main(int argc, char const *argv[])
{
    // 命名信号
    sem_t *sem = sem_open("mysem", O_CREAT | O_RDWR, 0644, 1);

    int pid = fork();
    if (pid == 0) // 子进程
    {
        sem_wait(sem);
        printer("disen666");
        sem_post(sem);
        _exit(0);
    }
    else if (pid > 0) // 父进程
    {
        sem_wait(sem);
        printer("jack888");
        sem_post(sem);
        wait(NULL); // 等待子进程退出

        printf("\n---over---\n");
        sem_close(sem);      // 关闭信号量
        sem_unlink("mysem"); // 删除信号量文件
    }
    return 0;
}
